unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image2: TImage;
    Image3: TImage;
    Timer1: TTimer;
    PaintBox1: TPaintBox;
    Button1: TButton;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Bevel1: TBevel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  rond:tbitmap;
  fleche:tbitmap;
  fond:tbitmap;
  savx,savy:integer;
  collisionr:trect;
  ax,ay:integer;
  c1,c2:tcolor;

implementation

{$R *.DFM}

// les 2 carres forms par chacun des sprites se chevauchent ???
procedure controle_carre(img1x,img1y,img1width,img1height,
                         img2x,img2y,img2width,img2height:integer);
begin
  intersectrect(collisionr,bounds(img1x,img1y,img1width,img1height),
                           bounds(img2x,img2y,img2width,img2height));
  if (collisionr.left<>collisionr.right) then// verifier collision
  begin
   form1.image4.canvas.draw(0,0,form1.image2.Picture.Bitmap);
    for ay:=collisionr.top to collisionr.Bottom do
    begin
      for ax:=collisionr.left to collisionr.right do
      begin
        // afficher les coordonnes des 2 images
        form1.label5.caption:='x3:'+inttostr(img1x);
        form1.label6.caption:='y3:'+inttostr(img1y);
        form1.label7.caption:='x2:'+inttostr(img2x);
        form1.label8.caption:='y2:'+inttostr(img2y);

        c1:=form1.image2.canvas.pixels[(ax-img1x),(ay-img1y)]; // Timage2
        c2:=form1.image3.canvas.pixels[ax-img2x,ay-img2y]; // Timage3

        if (c1=c2) and (c1=clwhite) then // collision
        begin
          form1.Image5.Canvas.Draw(0,0,form1.image6.picture.bitmap);
          form1.Image4.canvas.MoveTo(ax-img1x  ,ay-img1y);
          form1.Image4.canvas.lineTo(ax-img1x+1,ay-img1y);
         // exit;
        end;
      end;
    end;
  end;
//  afficher les coordonnes du rectangle de collision
  form1.label1.Caption:='ax :'+inttostr(collisionr.left);
  form1.label2.Caption:='ay :'+inttostr(collisionr.top);
  form1.label3.Caption:='ax1:'+inttostr(collisionr.right);
  form1.label4.Caption:='ay1:'+inttostr(collisionr.bottom);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  rond.free;
  fleche.free;
  fond.free;
  halt;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  rond:=tbitmap.create;
  rond.Assign(image2.Picture.Bitmap);
  fond:=tbitmap.create;
  fond.Assign(image1.Picture.Bitmap);
  fleche:=tbitmap.create;
  fleche.Assign(image3.Picture.Bitmap);
  savx:=0;savy:=0;
end;



procedure TForm1.Timer1Timer(Sender: TObject);
begin
  form1.paintbox1.canvas.draw(100,100,rond);
  form1.Image5.Canvas.Draw(0,0,form1.image7.picture.bitmap);
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  controle_carre(  x,  y,image2.width,image2.height,
                 100,100,image3.width,image3.Height);
  form1.paintbox1.canvas.draw(savx,savy,fond);
  form1.paintbox1.canvas.draw(x,y,fleche);
  savx:=x;savy:=y;
end;

end.
